/* Preload loading svg animation */
loading0 = new Image();
loading1 = new Image();
loading0.src = "../img/loading.svg";
loading1.src = "../img/loading.smil.svg";

function launchStreamer (e) {
    console.log ("Quality setting: " + e.target.dataset.quality);
    launchStreamerUI (e);
}
function launchStreamerUI (e) {
    var wrapper = document.getElementById ("wrapper");
        title = document.querySelector ("#title span"),
        notice = document.querySelector ("#notice span"),
        content = document.getElementById ("content");
        qualities = document.getElementById ("qualities");
    
    /* Add animation classes */
    title.classList.add ("quickFadeLeft");
    notice.classList.add ("quickFadeLeft");
    qualities.classList.add ("quickFadeDown");
    content.style.overflow = "hidden";
    
    /* Update messages and add loading icon */
    setTimeout (function () {
        wright.update ("#title span", {"content": "Launching Livestreamer"});
        wright.update ("#notice span", {"content": "Launching " + e.target.dataset.quality  + " stream..."});
        //title.innerHTML = "Launching Livestreamer";
        //notice.innerHTML = "Launching " + e.target.dataset.quality  + " stream...";
        var ui = wright.design ({
            "attribs": {
                "id": "loading",
                "class": ["loading", "quickBounce"]
            },
            "content": {
                "type": "object",
                "attribs": {
                    "type": "image/svg+xml",
                    "data": "../img/loading.svg"
                },
                "content": {
                    "type": "img",
                    "attribs": {
                        "alt": "Loading...",
                        "src": "../img/loading.smil.svg"
                    }
                }
            }
        });
        wright.append ("#wrapper #content", ui);
        wright.remove ("#wrapper #content", "#qualities");
        //content.appendChild (ui);
        //content.removeChild (qualities);
    }, 300);
    /* Remove classes and reduce clutter in DOM */
    setTimeout (function () {
        title.classList.remove ("quickFadeLeft");
        notice.classList.remove ("quickFadeLeft");
        qualities.classList.remove ("quickFadeDown");
        content.style.overflow = "";
    }, 600);
}

var ui = wright.design ({
    "attribs": {
        "id": "wrapper"
    },
    "content": [
        {
            "attribs": {
                "id": "title"
            },
            "content": [
                {
                    "type": "span",
                    "content": "Quality"
                },
                {
                    "type": "div",
                    "attribs": {
                        "id": "cog"
                    },
                    "content": {
                        "type": "img",
                        "attribs": {
                            "alt": "Options",
                            "src": "../img/options.svg"
                        }
                    }
                }
            ]
        },
        {
            "attribs": {
                "id": "notice"
            },
            "content": {
                "type": "span",
                "content": "Select stream quality"
            }
        },
        {
            "attribs": {
                "id": "content"
            },
            "content": {
                "empty": "true",
                "attribs": {
                    "id": "qualities",
                    "class": ["list", "smooth"]
                },
                "content": [
                    {
                        "attribs": {
                            "class": ["block"],
                            "dataset": {
                                "quality": "1080p"
                            }
                        },
                        "content": "1080p"
                    },
                    {
                        "attribs": {
                            "class": ["block"],
                            "dataset": {
                                "quality": "720p"
                            }
                        },
                        "content": "720p"
                    },
                    {
                        "attribs": {
                            "class": ["block"],
                            "dataset": {
                                "quality": "480p"
                            }
                        },
                        "content": "480p"
                    },
                    {
                        "attribs": {
                            "class": ["block"],
                            "dataset": {
                                "quality": "360p"
                            }
                        },
                        "content": "360p"
                    }
                ]
            }
        }
    ]
});

if (document.body != null) {
    document.body.appendChild(ui);
}

// Emit to main.js
var qualities = document.querySelectorAll ("#qualities .block");
// For each add click event
for (var i = 0; i < qualities.length; i++) {
    qualities[i].addEventListener("click", launchStreamer, false);
}
